#include "Angle.h"
#include "ADC.h"


int MIDANGLE = 5320;


/* GETRESISTORVALUE
 * Returnerer den mlte verdien p den variable resistoren i pot-meteret.
 */
int getResistorValue(void)
{
	int voltage = getmVoltage(ANGLEADCCHANNEL);
	double voltageRelation = (VOLTAGESUPPLY*1000/voltage)-1000;
	int resistorValue = CONSTRESISTOR*voltageRelation;
	return resistorValue/1000;
}

/* GETANGLE
 * Returnerer vinkelen til ekosksjelettet (i grader). Skal ligge mellom -90 og 90 grader.
 */
int getAngle(void)
{
	int resistorValue = getResistorValue();
	int angle = (resistorValue-MIDANGLE)*DEGREEPERRESISTANCE;
	return angle;
}


/* SETANGLEMIDPOINT
 * Setter resistorverdien som blir regnet som 0 grader. Alts nr hndleddet er rettet beint frem.
 */
void setAngleMidPoint(void)
{
	MIDANGLE = getResistorValue();	
}