/***********************************************************************/
/*                                                                     */
/*  FILE        :Eksoskjelett.c                                        */
/*  DATE        :Fri, Feb 21, 2014                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH7047                                                */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/
         
																							
																							
#include "iodefine.h"
#include "LED.h"
#include "DebugCom.h"
#include "Timer.h"
#include "interrupt_handlers.h"
#include "GlobVar.h"
#include "ADC.h"
#include "PWM.h"
#include "Vektcelle.h"
#include "Angle.h"
#include "CAN_interface.h"
#include "CAN.h"
#include "MambaCom.h"
#include "Servo.h"


#ifdef CPPAPP
//Initialize global constructors
extern "C" void __main()
{
  static int initialized;
  if (! initialized)
    {
      typedef void (*pfunc) ();
      extern pfunc __ctors[];
      extern pfunc __ctors_end[];
      pfunc *p;

      initialized = 1;
      for (p = __ctors_end; p > __ctors; )
	(*--p) ();

    }
}
#endif 

//Debug mode: Bestemmer hvordan kommunikasjonen ser ut over seriallinjen.
#define MODE_PUTTY	0
#define MODE_LABVIEW 1
#define MODE_SILENT 2

int DebugComMode = MODE_LABVIEW;

int periodicCounter = 0; //Brukes til  time periodiske oppgaver.




int main(void)
{
	char tempChar[2];
	tempChar[0] = ' ';
	tempChar[1] = '\0';
	
	initDebugCom();	
    initLEDs();
	initADCmodule(0);
	initPWM();
	initTimerInt();
	initMambaCom();
	initCANinterface();
	
	setLED(1,YELLOW);
		
	pStr("*************************INITIALISERING SLUTT************************\r\n\r\n\r\n");
	
	pStr("*************************PROGRAM START*******************************\r\n");
	pStr("Starter main-loop...\r\n");
	delay_cs(100);

	cleanTerminal();
	setLED(1,GREEN);	
	setVariableDebugMessage("none = %d",0);
	
	int testcounter = 0;

    while (1) 
	{	
		/* PERIODISKE OPPGAVER
		 * Hele blokken kjres 50 ganger i sekundet.
		 */
		if(doPeriodicTasks())
		{	
			periodicCounter++;
			testcounter++;
			
			/*OPPGAVER SOM SKAL KJRES 50 GANGER I SEKUNDET:*/
			startSingleScan(0);																			//Oppdaterer ADC-avlesning.
			MambaCom_setMambaAngle(getAngle());															//Setter Ekso-vinkel som referanse til Mamba.
			CAN_sendMessage(CAN_MAXIMUM_PRIORITY, CAN_READ_DATA, CAN_ANGLE_AND_ACCELERATION, 255, 0); 	//Sprr Mamba om vinkelen p slangerobotleddet.
			setDesiredAngle(MambaCom_getMambaAngle()); 													//Setter nsket vinkel til vinkelen til slangeroboten.					
			updatePID();																				//Oppdaterer PID-regulator.
			
			
			
			/*////////TEST
			if(testcounter>50)
				setDesiredAngle(0);
			if(testcounter>100)
				setDesiredAngle(60);
			if(testcounter>150)
			{
				setDesiredAngle(-60);
				testcounter = 0;
			}
			//////////TEST slutt*/
			
			
			/*OPPGAVER SOM SKAL KJRES 10 GANGER I SEKUNDET:*/
			if(periodicCounter>4)//(periodicCounter>4)
			{
				periodicCounter = 0;
				
				if(newInputReady())		//Leser input fra tastatur eller LanVIEW-applikasjon
				{
					tempChar[0] = getInputFromComputer(); 
				}
			
				if(tempChar[0] == 's') 	//Endrer verdien fra ADC-kanalen tilkoblet lastcella som representerer null last til verdien som mles nr 's' trykkes inn.
				{
					setSensorMidPoint();
					tempChar[0] = ' ';
					tempChar[1] = '\0';
					pStr("MVektsensor er resatt\n");	
				}
			
				if(tempChar[0] == 'v') 	//Endrer verdien fra ADC-kanalen tilkoblet potmeteret som representerer vinkel 0 verdien som mles nr 'v' trykkes inn.
				{
					setAngleMidPoint();
					tempChar[0] = ' ';
					tempChar[1] = '\0';
					pStr("MVinkel er resatt\n");	
				}
			
				switch (DebugComMode)
				{
					case MODE_PUTTY:	//Output tiltenkt PUTTY
						pStrWNum("Seconds passed: %d\r\n",sPassed);
						pStr("Siste input fra datamaskin: ");
						pStr(tempChar);
						pStr("\r\n");
						pStrWNum("EksoAngle: %d\r\n",getAngle());
						pStrWNum("MambaAngle: %d\r\n", MambaCom_getMambaAngle());
						pStrWNum("Pulsewidth [us]: %d\r\n",updatePID());
						pStr("\r\n\r\n\r\n");
						break;
					case MODE_LABVIEW:	//Output tiltenkt LabVIEW
						sendDataToLabview(getWeight(), MambaCom_getMambaAngle(), getAngle());
						break;
					case MODE_SILENT: //Debug av debug av debug av debug......
						pStrWNum("Pulsewidth [us]: %d\r\n",updatePID());
						pStrWNum("Error [deg]: %d\r\n",csSinceLastRun());
						updateAngleError();
						break;
				}
			}
		}	
	}
	
  return 0;
}


