#include "iodefine.h"
#include "LED.h"

 
void initLEDs(void){
	//LEDs styres av PORTD, PE20 og PE21.
	
	//Setter PORTD, PE20 og PE21 i I/O-mode. (Muligens undvendig pga init value = 0).
	//PORTD (se side 531 i datablad)
	PFC.PDCRL1.WORD = 0x0000;
	PFC.PDCRL2.WORD = 0x0000; 
	//PE20 og PE21 (se side 533 i datablad)
	PFC.PECRH.BIT.PE20MD = 0x00;
	PFC.PECRH.BIT.PE21MD = 0x00;
	
	//Setter samme pinner til  vre output-pinner (se side 542 og 544 i datablad)
	PFC.PDIORL.WORD = 0x01ff;
	PFC.PEIORH.BIT.B20 = 1;
    PFC.PEIORH.BIT.B21 = 1;
	
	setLED(1,OFF);
	setLED(2,OFF);
	setLED(3,OFF);
	setLED(4,OFF);
	setLED(5,OFF);
	
	pStr("LEDs er initialisert.\r\n");
}

void setLED(int LEDnumber, int state){
	int red; //Av/p-status til rd LED
	int green; //Av/p-status til grnn LED
	
	switch (state)
	{
		case OFF:
			red = 1;
			green = 1;
			break;
		case RED:
			red = 0;
			green = 1;
			break;
		case GREEN:
			red = 1;
			green = 0;
			break;
		case YELLOW:
			red = 0;
			green = 0;
			break;
	}
	
	switch (LEDnumber)
	{
		case 1:
			PE.DRH.BIT.B20 = red;
			PE.DRH.BIT.B21 = green;
			break;
		case 2:
			PD.DRL.BIT.B0 = red;
			PD.DRL.BIT.B1 = green;
			break;
		case 3:
			PD.DRL.BIT.B2 = red;
			PD.DRL.BIT.B3 = green;
			break;
		case 4:
			PD.DRL.BIT.B4 = red;
			PD.DRL.BIT.B5 = green;
			break;
		case 5:
			PD.DRL.BIT.B6 = red;
			PD.DRL.BIT.B7 = green;
			break;
	}
}
