#include "MambaCom.h"
#include "CAN.h"
#include "DebugCom.h"

int MambaAngle;


void initMambaCom(void)
{
	MambaAngle = 0;
}


/* MambaCom_saveObtainedMambaAngle
 * Denne funksjonen brukes av CAN_interface.c til  lagre vinkelen som blir sendt
 * over CAN-bussen fra Mamba.
 */
void MambaCom_saveObtainedMambaAngle(int newAngle)
{
	MambaAngle = newAngle;
}


int MambaCom_getMambaAngle(void)
{
	return MambaAngle;
}


/* MambaCom_setMambaAngle
 * Konverterer og sender en referansevinkel til Mamba. Regulatoren i Mamba vil s g til
 * denne vinkelposisjonen.
 */
void MambaCom_setMambaAngle(int newAngle)
{
		unsigned char sendData[8];
		int int_tmp;
		//Konverterer 'newAngle' slik at verdien er kompatibel med CAN-protokollen til Mamba.
		int_tmp = (int)( (newAngle+150)*10 );
		sendData[0] = (unsigned char)(int_tmp & 0xFF);
		sendData[1] = (unsigned char)(int_tmp >> 8);
		CAN_sendMessage(CAN_MEDIUM_PRIORITY, CAN_WRITE_DATA, CAN_ANGLE_REFERENCE, 255, sendData);
}